<?php
/** 
* Polish Language File developed by mybboard.pl for GeSHiCode 0.5
* Tłumaczenie: szulcu
* Poprawki: Ekipa Polskiego Supportu MyBB (mybboard.pl)
* Wersja 1.0
**/ 

/* Checks so the request is made from within MyBB */
if(!defined("IN_MYBB")){
    die("Direct access to GeSHi plugin is not allowed. -- <a href='http://www.jriddick.co.cc'>jRiddick</a>");
}
/** 
 * Creates the Information about GeSHiCode. 
 *
 * @return array
 */
function geshi_info()
{
	return array(
		"name"		    => "GeSHiCode",
		"description"	=> "Podświetlanie składni z możliwością dostosowania tagu MyCode.",
		"website"		=> "http://jriddick.co.cc",
		"author"		=> "jRiddick",
		"authorsite"	=> "http://jriddick.co.cc",
		"version"		=> "0.5",
        "guid" 			=> "2c1bc8e04bd608ad0cdc09842c8baff9",
		"compatibility"	=> "*"

	);
}

/**
 * Adds MyBB Hook
 */
$plugins->add_hook("parse_message", "geshi_run");

/**
 * GeSHi Activate & Deactivate
 */
function geshi_activate(){
require_once '../inc/adminfunctions_templates.php';
find_replace_templatesets("headerinclude","#".
preg_quote('<!-- <LINK rel="stylesheet" title="GeSHi" href="{$mybb->settings[\'bburl\']}/GeSHiCode/stylesheet/geshi.css" type="text/css"> -->').'#',
'<LINK rel="stylesheet" title="GeSHi" href="{$mybb->settings[\'bburl\']}/GeSHiCode/stylesheet/geshi.css" type="text/css">',0);


find_replace_templatesets("headerinclude","#".
preg_quote('<!-- <script type="text/javascript" src="{$mybb->settings[\'bburl\']}/GeSHiCode/js/geshi.js"></script> -->').'#',
'<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/GeSHiCode/js/geshi.js"></script>',0);
}
function geshi_deactivate(){
require_once '../inc/adminfunctions_templates.php';
find_replace_templatesets("headerinclude","#".
preg_quote('<LINK rel="stylesheet" title="GeSHi" href="{$mybb->settings[\'bburl\']}/GeSHiCode/stylesheet/geshi.css" type="text/css">').'#',
'<!-- <LINK rel="stylesheet" title="GeSHi" href="{$mybb->settings[\'bburl\']}/GeSHiCode/stylesheet/geshi.css" type="text/css"> -->',0);


find_replace_templatesets("headerinclude","#".
preg_quote('<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/GeSHiCode/js/geshi.js"></script>').'#',
'<!-- <script type="text/javascript" src="{$mybb->settings[\'bburl\']}/GeSHiCode/js/geshi.js"></script> -->',0);
}

/**
 * Includes the GeSHi class file.
 */
include_once(MYBB_ROOT."/GeSHiCode/class_geshi.php");
 
/**
 * GeSHi install
 *
 * @description Handles the installation of the script.
 *              This will create a new setting group and a new setting variable,
 *              Modify templatesets to include both the stylesheet and the javascript file.
 */
function geshi_install(){
	global $db, $theme;
	require_once '../inc/adminfunctions_templates.php';
	$query = $db->simple_select("settinggroups", "COUNT(*) as rows");
	$rows = $db->fetch_field($query, "rows");
	

	$insertarray = array(
		'name' => 'GeSHi', 
		'title' => 'GeSHi', 
		'description' => 'Ustawienia kolorowania składni GeSHi.', 
		'disporder' => 0, 
		'isdefault' => 0
	);
	$db->insert_query("settinggroups", $insertarray);
	$group['gid'] = $db->insert_id();


    $insertarray = array(
		'name' => 'GeSHi_tag',
		'title' => 'Tag MyCode',
		'description' => 'Wybierz tag, do którego wklejany będzie kod.',
		'optionscode' => 'text',
		'value' => 'geshi',
		'disporder' => 1,
		'gid' => $group['gid']
	);
	$db->insert_query("settings", $insertarray);

	rebuild_settings();
  

    find_replace_templatesets("headerinclude","#".preg_quote('{$newpmmsg}').'#',
    '<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/GeSHiCode/js/geshi.js"></script>
{$newpmmsg}');


    find_replace_templatesets("headerinclude","#".preg_quote('{$newpmmsg}').'#',
    '<LINK rel="stylesheet" title="GeSHi" href="{$mybb->settings[\'bburl\']}/GeSHiCode/stylesheet/geshi.css" type="text/css">
{$newpmmsg}');
}

/**
 * GeSHi is installed
 *
 * @description Checks if GeSHi is installed.
 *
 * @global $db
 * @return true|false
 */

function geshi_is_installed(){
	global $db;
	
	$query = $db->query("SELECT COUNT(*) AS num FROM ".TABLE_PREFIX."settinggroups WHERE name='GeSHi'");
	$num = $db->fetch_array($query);
	
	if($num['num'] > "0")
	{
		return true;
	}
	
	return false;
}

/**
 * Geshi Uninstall
 *
 * @description This will handle the removal of the plugin.
 *              This will remove the setting group and setting variable,
 *              and remove the stylesheet, javascript includes from headerinclude.
 */

function geshi_uninstall(){
	global $db;
	require_once '../inc/adminfunctions_templates.php';

	$db->write_query("DELETE FROM ".TABLE_PREFIX."settings WHERE name IN(
		'GeSHi_tag'
	)");
	$db->delete_query("settinggroups", "name = 'GeSHi'");
	rebuild_settings();
    

    find_replace_templatesets("headerinclude","#".
    preg_quote('<LINK rel="stylesheet" title="GeSHi" href="{$mybb->settings[\'bburl\']}/GeSHiCode/stylesheet/geshi.css" type="text/css">').'#','',0);


    find_replace_templatesets("headerinclude","#".
    preg_quote('<script type="text/javascript" src="{$mybb->settings[\'bburl\']}/GeSHiCode/js/geshi.js"></script>').'#','',0);
    
    find_replace_templatesets("headerinclude","#".
    preg_quote('<!--  -->').'#','',0);
}


/**
 * GeSHi Run
 *
 * @description This will handle the things that will be done when this is runned.
 *              It will check for the tag using [$tag][/$tag] and if found it will send
 *              it to highlight_code function.
 *
 * @var string $tag This will hold the tag string from the setting.
 */

function geshi_run($message)
{
   
    global $mybb;
    $tag = $mybb->settings['GeSHi_tag'];
	
	$pattern = "#\[".$tag."=([\w\-]+)](.*)\[/".$tag."]#Us";
    $message = preg_replace_callback($pattern, "highlight_code", $message);
}

/**
 * GeSHi Style.
 * 
 * @description This will handle the styling of the return value.
 *              There is an array that contains all the html data.
 *
 * @param string $title This contains the codebox title.
 * @param string $code This containts the text.
 * @param bool $hide This changes if it's a hidden box or not.
 * @return string $string Returns the HTML style.
 */

function style($title, $code, $rand_id, $hide=false) {
    
    $style['codeblock_show'] = '<div id="'.$rand_id['first'].'" class="codeblock_show">';
    $style['codeblock_hide'] = '<div id="'.$rand_id['first'].'" class="codeblock_hide">';
    $style['title'] = '<div class="geshi_title">Kod: '.$title.'';
    $style['linenumbers'] = '<div class="geshi_slogan">Numery linii: ';
    $style['expand'] = 'Wysokość: ';
    $style['link_hide'] = '<a href="#" onClick="geshichange(\''.$rand_id['first'].'\',\''.$rand_id['second'].'\'); return false;">WŁ/WYŁ</a>';
    $style['link_expand'] = '<a href="#" onClick="expand(\''.($rand_id['first']+5).'\',\''.($rand_id['second']+5).'\'); return false;">Zmień</a>';
    $style['body'] = '<div class="geshi_body">';
    $style['code_show'] = '<div id="'.($rand_id['first']+5).'" class="geshi_code"><code>'.$code.'</code></div>';
    $style['code_hide'] = '<div id="'.($rand_id['first']+5).'" class="code_hide"><code>'.$code.'</code></div>';
    $style['div'] = '</div>';

    if($hide) $string .= $style['codeblock_hide'];
    if(!$hide) $string .= $style['codeblock_show'];
   
    $string .= $style['title'].$style['linenumbers'].$style['link_hide'].' - '.$style['expand'].$style['link_expand'].$style['div'].$style['div'];
    
    if($hide) $string .= $style['body'].$style['code_hide'].$style['div'];
    if(!$hide) $string .= $style['body'].$style['code_show'].$style['div'];
    
    $string .= $style['div'];
    
    return $string;
}

/**
 * Highlight Code
 *
 * @description This handles all the highlighting.
 *              it will highlight the text with the appropriat language.
 *
 * @param array $result This contains the language name and the text to be highlighted.
 * @return string $text Returns the HTML.
 */

function highlight_code($result)
{
    /* Gets the value form the filter */
    $language = $result[1];
    $code = $result[2];
    
 /* @var array This contains all the replace information */
    $replace = array(
            'before' => array(
               "&#36;"   => "$",
               "&gt;"    => ">",
               "&lt;"    => "<",
               "&amp;"   => "&"
            ),
            
            'after' => array(
               "&amp;"   => "&",
               "\r"      => ""
            )
    );

    
    /* Replaces all the hits in the text */
    foreach($replace['before'] as $key=>$value)
    {
        $code = str_replace($key, $value, $code);
    }
    $code_spaces = $code;
    $code = preg_replace("/[\n]+/", "\n", $code);
    
    
    /* Trims the text */
	$code = ltrim($code);
	$code = rtrim($code);
    $code_spaces = ltrim($code_spaces);
    $code_spaces = rtrim($code_spaces);
    
    /* Creates a new GeSHi Class */
    $geshi = new geshi($code, $language);
    
    /* Sets the first GeSHi with Normal Line Numbers */
    $geshi->enable_line_numbers(GESHI_NORMAL_LINE_NUMBERS);
    $first_geshi = $geshi->parse_code();
    
    /* Sets the second GeSHi without Line Numbers */
    $geshi->enable_line_numbers(GESHI_NO_LINE_NUMBERS);
    $geshi->set_source($code_spaces);
    $second_geshi = $geshi->parse_code();
    
    /* Replaces all the hits in the GeSHied text */
    foreach($replace['after'] as $key=>$value)
    {
        $first_geshi = str_replace($key, $value, $first_geshi);
        $second_geshi = str_replace($key, $value, $second_geshi);
    }
    
    /* Replaces special hits in the GeSHied text */
    $second_geshi = str_replace("\n", "<br />", $second_geshi);
    
    /* Generate some random id for div tags */
    $rand_show['first'] = mt_rand(1875,1891986);
    $rand_show['second'] = mt_rand(1875,8186157);
    
    $rand_hide['first'] = $rand_show['second'];
    $rand_hide['second'] = $rand_show['first'];
    
    /* Changes some language names */
    if($language == 'cpp')$language = 'c++';
    if($language == 'javascript')$language = 'JavaScript';
    
    /* Gets the style of the GeSHied text */
    $number_geshi  = style(strtoupper($language), $first_geshi, $rand_show);
    $copy_geshi = style(strtoupper($language), $second_geshi, $rand_hide, true); /* This box will be hidden at start */
    
    /* Puts the HTML code together */
    $text = $number_geshi.$copy_geshi;
    
    $code = '';
    $language = '';
    
    return $text;
}
?>